import { AbstractQueryGenerator } from '../abstract/query-generator';
import type { RemoveIndexQueryOptions, TableNameOrModel } from '../abstract/query-generator-typescript';
import type { ListSchemasQueryOptions, ListTablesQueryOptions, ShowConstraintsQueryOptions } from '../abstract/query-generator.types';
/**
 * Temporary class to ease the TypeScript migration
 */
export declare class Db2QueryGeneratorTypeScript extends AbstractQueryGenerator {
    protected _getTechnicalSchemaNames(): string[];
    listSchemasQuery(options?: ListSchemasQueryOptions): string;
    describeTableQuery(tableName: TableNameOrModel): string;
    listTablesQuery(options?: ListTablesQueryOptions): string;
    private _getConstraintType;
    showConstraintsQuery(tableName: TableNameOrModel, options?: ShowConstraintsQueryOptions): string;
    showIndexesQuery(tableName: TableNameOrModel): string;
    removeIndexQuery(tableName: TableNameOrModel, indexNameOrAttributes: string | string[], options?: RemoveIndexQueryOptions): string;
    versionQuery(): string;
    tableExistsQuery(tableName: TableNameOrModel): string;
}
