import type { Sequelize } from '../../sequelize.js';
import { AbstractDialect } from '../abstract';
import { MariaDbConnectionManager } from './connection-manager';
import { MariaDbQuery } from './query';
import { MariaDbQueryGenerator } from './query-generator';
import { MariaDbQueryInterface } from './query-interface';
export declare class MariaDbDialect extends AbstractDialect {
    static supports: import("../abstract").DialectSupports;
    readonly TICK_CHAR_LEFT = "`";
    readonly TICK_CHAR_RIGHT = "`";
    readonly defaultVersion = "10.4.30";
    readonly dataTypesDocumentationUrl = "https://mariadb.com/kb/en/library/resultset/#field-types";
    readonly queryGenerator: MariaDbQueryGenerator;
    readonly connectionManager: MariaDbConnectionManager;
    readonly queryInterface: MariaDbQueryInterface;
    readonly Query: typeof MariaDbQuery;
    constructor(sequelize: Sequelize);
    createBindCollector(): import("../abstract").BindCollector;
    escapeString(value: string): string;
    canBackslashEscape(): boolean;
    getDefaultSchema(): string;
    static getDefaultPort(): number;
}
