import type { Expression } from '../../sequelize.js';
import { AbstractQueryGenerator } from '../abstract/query-generator';
import type { EscapeOptions, QueryGeneratorOptions, RemoveIndexQueryOptions, TableNameOrModel } from '../abstract/query-generator-typescript';
import type { ListSchemasQueryOptions, ListTablesQueryOptions, ShowConstraintsQueryOptions } from '../abstract/query-generator.types.js';
/**
 * Temporary class to ease the TypeScript migration
 */
export declare class MariaDbQueryGeneratorTypeScript extends AbstractQueryGenerator {
    constructor(options: QueryGeneratorOptions);
    protected _getTechnicalSchemaNames(): string[];
    listSchemasQuery(options?: ListSchemasQueryOptions): string;
    describeTableQuery(tableName: TableNameOrModel): string;
    listTablesQuery(options?: ListTablesQueryOptions): string;
    showConstraintsQuery(tableName: TableNameOrModel, options?: ShowConstraintsQueryOptions): string;
    showIndexesQuery(tableName: TableNameOrModel): string;
    removeIndexQuery(tableName: TableNameOrModel, indexNameOrAttributes: string | string[], options?: RemoveIndexQueryOptions): string;
    getToggleForeignKeyChecksQuery(enable: boolean): string;
    jsonPathExtractionQuery(sqlExpression: string, path: ReadonlyArray<number | string>, unquote: boolean): string;
    formatUnquoteJson(arg: Expression, options?: EscapeOptions): string;
    versionQuery(): string;
}
