import { AbstractQueryGenerator } from '../abstract/query-generator';
import type { TableNameOrModel } from '../abstract/query-generator-typescript';
import type { CreateDatabaseQueryOptions, ListDatabasesQueryOptions, ListSchemasQueryOptions, ListTablesQueryOptions, ShowConstraintsQueryOptions } from '../abstract/query-generator.types';
/**
 * Temporary class to ease the TypeScript migration
 */
export declare class SnowflakeQueryGeneratorTypeScript extends AbstractQueryGenerator {
    protected _getTechnicalSchemaNames(): string[];
    createDatabaseQuery(database: string, options?: CreateDatabaseQueryOptions): string;
    listDatabasesQuery(options?: ListDatabasesQueryOptions): string;
    listSchemasQuery(options?: ListSchemasQueryOptions): string;
    describeTableQuery(tableName: TableNameOrModel): string;
    listTablesQuery(options?: ListTablesQueryOptions): string;
    showConstraintsQuery(tableName: TableNameOrModel, options?: ShowConstraintsQueryOptions): string;
    showIndexesQuery(): string;
    versionQuery(): string;
}
