import { AbstractQueryGenerator } from '../abstract/query-generator';
import type { RemoveIndexQueryOptions, TableNameOrModel } from '../abstract/query-generator-typescript';
import type { ListTablesQueryOptions, RemoveColumnQueryOptions, ShowConstraintsQueryOptions } from '../abstract/query-generator.types';
import type { ColumnsDescription } from '../abstract/query-interface.types';
/**
 * Temporary class to ease the TypeScript migration
 */
export declare class SqliteQueryGeneratorTypeScript extends AbstractQueryGenerator {
    createSchemaQuery(): string;
    dropSchemaQuery(): string;
    describeTableQuery(tableName: TableNameOrModel): string;
    describeCreateTableQuery(tableName: TableNameOrModel): string;
    listTablesQuery(options?: ListTablesQueryOptions): string;
    showConstraintsQuery(tableName: TableNameOrModel, _options?: ShowConstraintsQueryOptions): string;
    showIndexesQuery(tableName: TableNameOrModel): string;
    getToggleForeignKeyChecksQuery(enable: boolean): string;
    removeColumnQuery(_table: TableNameOrModel, _columnName: string, _options?: RemoveColumnQueryOptions): string;
    removeIndexQuery(tableName: TableNameOrModel, indexNameOrAttributes: string | string[], options?: RemoveIndexQueryOptions): string;
    _replaceTableQuery(tableName: TableNameOrModel, attributes: ColumnsDescription, createTableSql?: string): string;
    private escapeTable;
    versionQuery(): string;
    tableExistsQuery(tableName: TableNameOrModel): string;
}
